let originalHtmlStyles = null
let originalBodyStyles = null
let isActive = false
let selection = null

const openExt = async (msg, sender) => {
  selection = getSelectedHTML()
  originalBodyStyles = document.body.style
  originalHtmlStyles = document.documentElement.style

  browser.tabs.executeScript({
    file: 'index.js',
  })

  isActive = true
  return isActive
}

const closeExt = async (msg, sender) => {
  document.body.style = originalBodyStyles
  document.documentElement.style = originalHtmlStyles
  isActive = false
  return isActive
}

const toggleExt = async (msg, sender) => {
  const fn = isActive ? closeExt : openExt
  return await fn(msg, sender)
}

const getSelection = async (msg, sender) => {
  return selection
}

const handlers = {
  openExt,
  closeExt,
  toggleExt,
  getSelection,
}

browser.runtime.onMessage.addListener(async (msg, sender) => {
  if (msg.ext !== 'tayl') return false
  const handler = handlers[msg.type]
  if (!handler) return
  return await handler(msg, sender)
})

/**
 * Helper functions
 */

function getSelectedHTML() {
  var html = ''
  if (typeof window.getSelection != 'undefined') {
    var sel = window.getSelection()
    if (sel.rangeCount) {
      var container = document.createElement('div')
      for (var i = 0, len = sel.rangeCount; i < len; ++i) {
        container.appendChild(sel.getRangeAt(i).cloneContents())
      }
      html = container.innerHTML
    }
  } else if (typeof document.selection != 'undefined') {
    if (document.selection.type == 'Text') {
      html = document.selection.createRange().htmlText
    }
  }
  return html
}

